<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta charset="utf-8" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title>test for Diagram.add_node</title>
<script type="text/javascript" src="../js.lib/DomTemplate.js"></script>
<script type="text/javascript" src="../js.lib/Motion.js"></script>
<script type="text/javascript" src="../GitDiagram.js"></script>
<script type="text/javascript" src="make-sample-trees.js"></script>
<script type="text/javascript">
/* <![CDATA[ */

function test_determine_branch_offset( t )
{
	t.plan( 7 );
	var diagram=new GitDiagram( { container_element: document.getElementById( "diagram" ) } );
	var trunk_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:1,offset:0}, y: 4 }, { x: {date:2,offset:0}, y: 0 }, { x: {date:5,offset:0}, y: 3 }, { x: {date:6,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ];
	var branch_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:1,offset:0}, y: -1 }, { x: {date:2,offset:0}, y: 0 }, { x: {date:3,offset:0}, y: -3 }, { x: {date:4,offset:0}, y: 0 }, { x: {date:6,offset:0}, y: 0 } ];
	t.eq( GitDiagram._determine_branch_offset( 5, 1, branch_shape, trunk_shape ), 6, "branch 1 offset 5" );
	t.eq( GitDiagram._determine_branch_offset( 4, 1, branch_shape, trunk_shape ), 6, "branch 1 offset 4" );
	var branch2_shape=[ { x: {date:1,offset:0}, y: 0 }, { x: {date:3,offset:0}, y: -3 }, { x: {date:4,offset:0}, y: 0 }, { x: {date:6,offset:0}, y: 0 } ];
	t.eq( GitDiagram._determine_branch_offset( 4, 1, branch2_shape, trunk_shape ), 5, "branch 2 offset 4" );
	var trunk2_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: 4 }, { x: {date:2,offset:0}, y: 0 }, { x: {date:5,offset:0}, y: 3 }, { x: {date:6,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ];
	t.eq( GitDiagram._determine_branch_offset( 5, 1, branch_shape, trunk2_shape ), 6, "trunk 2 branch 1 offset 5" );
	t.eq( GitDiagram._determine_branch_offset( 4, 1, branch_shape, trunk2_shape ), 6, "trunk 2 branch 1 offset 4" );
	var trunk3_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:1,offset:0}, y: -4 }, { x: {date:2,offset:0}, y: 0 }, { x: {date:5,offset:0}, y: -3 }, { x: {date:6,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ];
	var branch3_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:1,offset:0}, y: 1 }, { x: {date:2,offset:0}, y: 0 }, { x: {date:3,offset:0}, y: 3 }, { x: {date:4,offset:0}, y: 0 }, { x: {date:6,offset:0}, y: 0 } ];
	t.eq( GitDiagram._determine_branch_offset( 1, -1, branch3_shape, trunk3_shape ), -6, "trunk 3 branch 3 offset -1" );

	var trunk4_shape=[ {x: {date:0,offset:0}, y: 0}, { x: {date:5,offset:0}, y: 0 } ];
	var branch4_shape=[ {x: {date:0,offset:0}, y: 0}, {x: {date:2,offset:0}, y: -2}, {x: {date:3,offset:0}, y: -2} ];
	t.eq( GitDiagram._determine_branch_offset( 0, 1, branch4_shape, trunk4_shape ), 3, "trunk 4 branch 4 offset 1" );
}

function test_expand_branch( t )
{
	t.plan( 10 );
	var trunk_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: 1 }, { x: {date:5,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ];
	t.eq( GitDiagram._expand_shape( 0, trunk_shape, trunk_shape ), trunk_shape, "trunk 1 expanded with itself offset 0" );
	t.eq( GitDiagram._expand_shape( 1, trunk_shape, trunk_shape ), [ { x: {date:0,offset:0}, y: 1 }, { x: {date:2,offset:0}, y: 2 }, { x: {date:5,offset:0}, y: 1 }, { x: {date:8,offset:0}, y: 1 } ], "trunk 1 expanded with itself offset 1" );
	var branch_shape=[ { x: {date:1,offset:0}, y: 1 }, { x: {date:1,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: 5 }, { x: {date:4,offset:0}, y: 5 } ];
	t.eq( GitDiagram._expand_shape( 0, branch_shape, branch_shape ), branch_shape, "branch 1 expanded with itself offset 0" );
	t.eq( GitDiagram._expand_shape( 1, branch_shape, branch_shape ), [ { x: {date:1,offset:0}, y: 2 }, { x: {date:1,offset:0}, y: 1 }, { x: {date:2,offset:0}, y: 6 }, { x: {date:4,offset:0}, y: 6 } ], "branch 1 expanded with itself offset 1" );
	t.eq( GitDiagram._expand_shape( 0, branch_shape, trunk_shape ), [ { x: {date:0,offset:0}, y: 0 }, { x: {date:1,offset:0}, y: 1 }, { x: {date:1,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: 5 }, { x: {date:4,offset:0}, y: 1 }, { x: {date:5,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ], "trunk 1 branch 1 offset 0" );
	t.eq( GitDiagram._expand_shape( 0, trunk_shape, branch_shape ), [ { x: {date:0,offset:0}, y: 0 }, { x: {date:1,offset:0}, y: 1 }, { x: {date:1,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: 5 }, { x: {date:4,offset:0}, y: 1 }, { x: {date:5,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ], "trunk 1 branch 1 offset 0 in reverse" );
	var trunk2_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: -1 }, { x: {date:5,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ];
	t.eq( GitDiagram._expand_shape( 0, trunk2_shape, trunk2_shape ), trunk2_shape, "trunk 2 expanded with itself offset 0" );
	t.eq( GitDiagram._expand_shape( -1, trunk2_shape, trunk2_shape ), [ { x: {date:0,offset:0}, y: -1 }, { x: {date:2,offset:0}, y: -2 }, { x: {date:5,offset:0}, y: -1 }, { x: {date:8,offset:0}, y: -1 } ], "trunk 2 expanded with itself offset -1" );
	var branch2_shape=[ { x: {date:1,offset:0}, y: -1 }, { x: {date:1,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: -5 }, { x: {date:4,offset:0}, y: -5 } ];
	t.eq( GitDiagram._expand_shape( 0, branch2_shape, trunk2_shape ), [ { x: {date:0,offset:0}, y: 0 }, { x: {date:1,offset:0}, y: -1 }, { x: {date:1,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: -5 }, { x: {date:4,offset:0}, y: -1 }, { x: {date:5,offset:0}, y: 0 }, { x: {date:8,offset:0}, y: 0 } ], "trunk 2 branch 2 offset 0" );
	var trunk3_shape=[ { x: {date:0,offset:0}, y: 0 }, { x: {date:10,offset:0}, y: 0 } ];
	var branch3_shape=[ { x: {date:2,offset:0}, y: 2 } ];
	t.eq( GitDiagram._expand_shape( 1, branch3_shape, trunk3_shape ), [ { x: {date:0,offset:0}, y: 0 }, { x: {date:2,offset:0}, y: 3 }, { x: {date:2,offset:0}, y: 0 }, { x: {date:10,offset:0}, y: 0 } ], "trunk 3 branch 3 offset 1" );
}


function get_all_nodes_something( diagram, something )
{
	var result={};
	for( var id in diagram.m_nodes ) {
		result[id]=diagram.m_nodes[id][something];
	}
	return result;
}
function get_date_columns_something( diagram, something )
{
	var values=[];
	for( var i=0; i<diagram.m_date_columns.length; ++i ) {
		var value=diagram.m_date_columns[i][something];
		if( something=="date" ) {
			value=date_to_offset( value )
		}
		values.push( value );
	}
	return values;
}

function test_place_node_subtree( t )
{
	t.plan( 8 );
	var diagram=new GitDiagram( { container_element: document.getElementById( "diagram" ) } );
	GitDiagram._g_step_x[diagram.m_style]=0.8;
	GitDiagram._g_branch_angle=0.2;
	make_sample_tree1( diagram );

// now, _place_node_subtree does not work outside place_nodes (it depends on first pass setting node dates)
//	diagram._place_node_subtree( diagram.m_nodes[8], diagram.m_nodes[8].date );
//	t.eq( get_date_columns_something( diagram, "date" ), [0, 1, 2, 3], "date_columns 1" );
//	t.eq( get_all_nodes_something( diagram, "offset_y" ), { 1: 0, 2: 0, 3: -1, 4: -1, 5: -2, 6: 0, 7: 0, 8: null, 9: null }, "offset_y for every node. 1." );

	make_sample_tree1a( diagram );

	diagram.place_nodes();
	t.eq( get_date_columns_something( diagram, "date" ), [0, 1, 2, 3, 4, 5, 7], "date_columns 1" );
	t.eq( get_all_nodes_something( diagram, "absolute_y" ), { 1: -3, 2: -3, 3: -3, 4: -4, 5: -5, 6: 0, 7: 0, 8: 0, 9: null, 10: 0, 11: -1, 12: -2, 13: 1, 14: null, 15: 0 }, "absolute_y for every node. 2." );
	t.eq( get_all_nodes_something( diagram, "offset_x" ), { 1: 0.4, 2: 0.4, 3: 0.4, 4: 0.4, 5: 0.4, 6: 0.4, 7: 0.4, 8: 0.4, 9: null, 10: 0.4, 11: 0.4, 12: 0.4, 13: 0.4, 14: null, 15: 0.4 }, "offset_x for every node 2" );

	var diagram2=new GitDiagram( { container_element: document.getElementById( "diagram" ) } );
	make_sample_tree2( diagram2 );

	diagram2.place_nodes();
	t.eq( get_all_nodes_something( diagram2, "offset_y" ), { 1: 0, 2: 0, 3: 0, 4: 0, 5: 0, 6: 0, 7: null, 8: -1, 9: -1, 10: -1, 11: -1, 12: -1, 13: 1, 14: 2, 15: 0, 100: null }, "offset_y for every node for diagram2" );
	t.eq( get_all_nodes_something( diagram2, "offset_x" ), { 1: 0.4, 2: 0.4*3, 3: 0.4, 4: 0.4, 5: 0.4, 6: 0.4, 7: 0.4, 8: 0.4*3+0.2, 9: 0.4+0.2, 10: 0.4, 11: 0.4+0.2, 12: 0.4+0.2, 13: 0.4, 14: 0.4, 15: 0.4, 100: null }, "offset_x for every node for diagram2" );
	t.eq( get_date_columns_something( diagram2, "date" ), [1, 2, 3, 5, 7, 8, 9, 10, 11], "date column dates for diagram2" );
	t.eq( get_date_columns_something( diagram2, "width" ), [ 0.8, 0.8, 0.4+0.2+0.4, 1, 0.8, 0.8, 0.4*3+0.2+0.4, 0.8, 0.8 ], "date column widths for diagram2" );
	t.eq( get_date_columns_something( diagram2, "absolute_x" ), [ 0, 0.8, 2*0.8, 2*0.8+1, 2*0.8+2, 3*0.8+2, 4*0.8+2, 5*0.8+3, 5*0.8+3+0.8 ], "date column absolute_x for diagram2" );
}




/* ]]> */
</script>
</head>
<body>
<div id="diagram"></div>
</body>
</html>
